/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.111 Revision 1.134
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.111 2011/12/27 16:04:27 pesa Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.134 2012/07/10 21:43:19 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Qt herd <qt@gentoo.org> 7# Qt herd <qt@gentoo.org>
8# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
9# @DESCRIPTION: 9# @DESCRIPTION:
10# This eclass contains various functions that are used when building Qt4. 10# This eclass contains various functions that are used when building Qt4.
11 11
12case ${EAPI} in
13 2|3|4) : ;;
14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
12inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
13 28
14MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
15MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
16 31
17HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/" 32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH=${PV%.9999}
37 ;;
38 release)
39 if version_is_at_least 4.8.1; then
40 SRC_URI="http://releases.qt-project.org/qt4/source/${MY_P}.tar.gz"
41 else
18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz" 42 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
19LICENSE="|| ( LGPL-2.1 GPL-3 )" 43 fi
44 ;;
45esac
20 46
21IUSE="aqua debug pch" 47IUSE="aqua debug pch"
22
23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && 48[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE+=" +exceptions"
24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
25 IUSE+=" +exceptions"
26
27if version_is_at_least 4.7.99999999; then 49if version_is_at_least 4.8; then
28 IUSE+=" c++0x qpa" 50 [[ ${CATEGORY}/${PN} != x11-libs/qt-webkit ]] && IUSE+=" c++0x"
51 version_is_at_least 4.8.3 || IUSE+=" qpa"
29fi 52fi
30 53
31DEPEND="dev-util/pkgconfig" 54DEPEND="virtual/pkgconfig"
55if [[ ${QT4_BUILD_TYPE} == live ]]; then
56 DEPEND+=" dev-lang/perl"
57fi
58
32RDEPEND=" 59RDEPEND="
33 !<x11-libs/qt-assistant-${PV} 60 !<x11-libs/qt-assistant-${PV}:4
34 !>x11-libs/qt-assistant-${PV}-r9999 61 !>x11-libs/qt-assistant-${PV}-r9999:4
62 !<x11-libs/qt-bearer-${PV}:4
63 !>x11-libs/qt-bearer-${PV}-r9999:4
35 !<x11-libs/qt-core-${PV} 64 !<x11-libs/qt-core-${PV}:4
36 !>x11-libs/qt-core-${PV}-r9999 65 !>x11-libs/qt-core-${PV}-r9999:4
37 !<x11-libs/qt-dbus-${PV} 66 !<x11-libs/qt-dbus-${PV}:4
38 !>x11-libs/qt-dbus-${PV}-r9999 67 !>x11-libs/qt-dbus-${PV}-r9999:4
39 !<x11-libs/qt-declarative-${PV} 68 !<x11-libs/qt-declarative-${PV}:4
40 !>x11-libs/qt-declarative-${PV}-r9999 69 !>x11-libs/qt-declarative-${PV}-r9999:4
41 !<x11-libs/qt-demo-${PV} 70 !<x11-libs/qt-demo-${PV}:4
42 !>x11-libs/qt-demo-${PV}-r9999 71 !>x11-libs/qt-demo-${PV}-r9999:4
43 !<x11-libs/qt-gui-${PV} 72 !<x11-libs/qt-gui-${PV}:4
44 !>x11-libs/qt-gui-${PV}-r9999 73 !>x11-libs/qt-gui-${PV}-r9999:4
45 !<x11-libs/qt-multimedia-${PV} 74 !<x11-libs/qt-multimedia-${PV}:4
46 !>x11-libs/qt-multimedia-${PV}-r9999 75 !>x11-libs/qt-multimedia-${PV}-r9999:4
47 !<x11-libs/qt-opengl-${PV} 76 !<x11-libs/qt-opengl-${PV}:4
48 !>x11-libs/qt-opengl-${PV}-r9999 77 !>x11-libs/qt-opengl-${PV}-r9999:4
78 !<x11-libs/qt-openvg-${PV}:4
79 !>x11-libs/qt-openvg-${PV}-r9999:4
49 !<x11-libs/qt-phonon-${PV} 80 !<x11-libs/qt-phonon-${PV}:4
50 !>x11-libs/qt-phonon-${PV}-r9999 81 !>x11-libs/qt-phonon-${PV}-r9999:4
51 !<x11-libs/qt-qt3support-${PV} 82 !<x11-libs/qt-qt3support-${PV}:4
52 !>x11-libs/qt-qt3support-${PV}-r9999 83 !>x11-libs/qt-qt3support-${PV}-r9999:4
53 !<x11-libs/qt-script-${PV} 84 !<x11-libs/qt-script-${PV}:4
54 !>x11-libs/qt-script-${PV}-r9999 85 !>x11-libs/qt-script-${PV}-r9999:4
55 !<x11-libs/qt-sql-${PV} 86 !<x11-libs/qt-sql-${PV}:4
56 !>x11-libs/qt-sql-${PV}-r9999 87 !>x11-libs/qt-sql-${PV}-r9999:4
57 !<x11-libs/qt-svg-${PV} 88 !<x11-libs/qt-svg-${PV}:4
58 !>x11-libs/qt-svg-${PV}-r9999 89 !>x11-libs/qt-svg-${PV}-r9999:4
59 !<x11-libs/qt-test-${PV} 90 !<x11-libs/qt-test-${PV}:4
60 !>x11-libs/qt-test-${PV}-r9999 91 !>x11-libs/qt-test-${PV}-r9999:4
61 !<x11-libs/qt-webkit-${PV} 92 !<x11-libs/qt-webkit-${PV}:4
62 !>x11-libs/qt-webkit-${PV}-r9999 93 !>x11-libs/qt-webkit-${PV}-r9999:4
63 !<x11-libs/qt-xmlpatterns-${PV} 94 !<x11-libs/qt-xmlpatterns-${PV}:4
64 !>x11-libs/qt-xmlpatterns-${PV}-r9999 95 !>x11-libs/qt-xmlpatterns-${PV}-r9999:4
65" 96"
66 97
67S=${WORKDIR}/${MY_P} 98S=${WORKDIR}/${MY_P}
68 99
69# @FUNCTION: qt4-build_pkg_setup 100# @FUNCTION: qt4-build_pkg_setup
70# @DESCRIPTION: 101# @DESCRIPTION:
71# Sets up PATH and LD_LIBRARY_PATH. 102# Sets up PATH and LD_LIBRARY_PATH.
72qt4-build_pkg_setup() { 103qt4-build_pkg_setup() {
73 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 104 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
74 105
75 # Protect users by not allowing downgrades between releases 106 # Protect users by not allowing downgrades between releases.
76 # Downgrading revisions within the same release should be allowed 107 # Downgrading revisions within the same release should be allowed.
77 if has_version '>'${CATEGORY}/${P}-r9999; then 108 if has_version ">${CATEGORY}/${P}-r9999:4"; then
78 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then 109 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
79 eerror "Sanity check to keep you from breaking your system:" 110 eerror " *** Sanity check to keep you from breaking your system ***"
80 eerror " Downgrading Qt is completely unsupported and will break your system!" 111 eerror "Downgrading Qt is completely unsupported and will break your system!"
81 die "aborting to save your system" 112 die "aborting to save your system"
82 else 113 else
83 ewarn "Downgrading Qt is completely unsupported and will break your system!" 114 ewarn "Downgrading Qt is completely unsupported and will break your system!"
84 fi 115 fi
85 fi
86
87 if [[ ${PN} == "qt-webkit" ]]; then
88 eshopts_push -s extglob
89 if is-flagq '-g?(gdb)?([1-9])'; then
90 echo
91 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
92 ewarn "You may experience really long compilation times and/or increased memory usage."
93 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
94 ewarn "For more info check out bug #307861"
95 echo
96 fi
97 eshopts_pop
98 fi 116 fi
99 117
100 PATH="${S}/bin${PATH:+:}${PATH}" 118 PATH="${S}/bin${PATH:+:}${PATH}"
101 if [[ ${CHOST} != *-darwin* ]]; then 119 if [[ ${CHOST} != *-darwin* ]]; then
102 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 120 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
107 # avoid extract failure. 125 # avoid extract failure.
108 [[ ${CHOST} == *-apple-darwin* ]] && \ 126 [[ ${CHOST} == *-apple-darwin* ]] && \
109 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 127 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
110 ${QT4_EXTRACT_DIRECTORIES}" 128 ${QT4_EXTRACT_DIRECTORIES}"
111 fi 129 fi
112
113 # Make sure ebuilds use the required EAPI
114 if [[ ${EAPI} != [23] ]]; then
115 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
116 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
117 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
118 die "qt4-build eclass requires EAPI=2 or EAPI=3"
119 fi
120
121 if ! version_is_at_least 4.1 $(gcc-version); then
122 ewarn "Using a GCC version lower than 4.1 is not supported!"
123 fi
124} 130}
131
132# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
133# @DEFAULT_UNSET
134# @DESCRIPTION:
135# Space-separated list including the directories that will be extracted from
136# Qt tarball.
125 137
126# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 138# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
139# @DEFAULT_UNSET
127# @DESCRIPTION: 140# @DESCRIPTION:
128# Arguments for build_target_directories. Takes the directories in which the 141# Arguments for build_target_directories. Takes the directories in which the
129# code should be compiled. This is a space-separated list. 142# code should be compiled. This is a space-separated list.
130
131# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
132# @DESCRIPTION:
133# Space-separated list including the directories that will be extracted from
134# Qt tarball.
135 143
136# @FUNCTION: qt4-build_src_unpack 144# @FUNCTION: qt4-build_src_unpack
137# @DESCRIPTION: 145# @DESCRIPTION:
138# Unpacks the sources. 146# Unpacks the sources.
139qt4-build_src_unpack() { 147qt4-build_src_unpack() {
140 setqtenv 148 setqtenv
141 local target targets= 149
150 if ! version_is_at_least 4.1 $(gcc-version); then
151 ewarn "Using a GCC version lower than 4.1 is not supported."
152 fi
153
154 if [[ ${PN} == qt-webkit ]]; then
155 eshopts_push -s extglob
156 if is-flagq '-g?(gdb)?([1-9])'; then
157 echo
158 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
159 ewarn "You may experience really long compilation times and/or increased memory usage."
160 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
161 ewarn "For more info check out https://bugs.gentoo.org/307861"
162 echo
163 fi
164 eshopts_pop
165 fi
166
167 case ${QT4_BUILD_TYPE} in
168 live)
169 git-2_src_unpack
170 ;;
171 release)
172 local tarball="${MY_P}.tar.gz" target= targets=
142 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 173 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
143 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 174 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
144 ${QT4_EXTRACT_DIRECTORIES}; do 175 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
176 do
145 targets+=" ${MY_P}/${target}" 177 targets+="${MY_P}/${target} "
146 done 178 done
147 179
180 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
148 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 181 tar -xzf "${DISTDIR}/${tarball}" ${targets}
149 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 182 eend $? || die "failed to unpack"
183 ;;
184 esac
150} 185}
151 186
152# @ECLASS-VARIABLE: PATCHES 187# @ECLASS-VARIABLE: PATCHES
153# @DEFAULT_UNSET 188# @DEFAULT_UNSET
154# @DESCRIPTION: 189# @DESCRIPTION:
166# @DESCRIPTION: 201# @DESCRIPTION:
167# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 202# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
168# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf. 203# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
169qt4-build_src_prepare() { 204qt4-build_src_prepare() {
170 setqtenv 205 setqtenv
171 cd "${S}"
172 206
207 if [[ ${QT4_BUILD_TYPE} == live ]]; then
208 QTDIR="." ./bin/syncqt || die "syncqt failed"
209 fi
210
173 if version_is_at_least "4.7"; then 211 if version_is_at_least 4.7; then
174 # fix libX11 dependency on non X packages 212 # avoid X11 dependency in non-gui packages
175 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns" 213 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
176 has ${PN} ${nolibx11_pkgs} && qt_nolibx11 214 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
177
178 qt_assistant_cleanup
179 fi 215 fi
180 216
181 if use aqua; then 217 if use aqua; then
182 # provide a proper macx-g++-64 218 # provide a proper macx-g++-64
183 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 219 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
191 skip_qmake_build 227 skip_qmake_build
192 skip_project_generation 228 skip_project_generation
193 symlink_binaries_to_buildtree 229 symlink_binaries_to_buildtree
194 fi 230 fi
195 231
196 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 232 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
197 # qmake bus errors with -O2 but -O3 works 233 # qmake bus errors with -O2 or -O3 but -O1 works
234 # Bug 373061
198 replace-flags -O2 -O3 235 replace-flags -O[23] -O1
199 fi 236 fi
200 237
201 # Bug 178652 238 # Bug 178652
202 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 239 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
203 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 240 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
204 append-flags -fno-gcse 241 append-flags -fno-gcse
205 fi 242 fi
206 243
207 if use_if_iuse c++0x; then 244 if use_if_iuse c++0x; then
208 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
209 ewarn "this is an official standard, some of the reverse dependencies"
210 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
211 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
212 ewarn "disabled."
213 append-flags -std=c++0x 245 append-cxxflags -std=c++0x
214 fi 246 fi
215 247
216 # Unsupported old gcc versions - hardened needs this :( 248 # Unsupported old gcc versions - hardened needs this :(
217 if [[ $(gcc-major-version) -lt 4 ]] ; then 249 if [[ $(gcc-major-version) -lt 4 ]]; then
218 ewarn "Appending -fno-stack-protector to CXXFLAGS" 250 ewarn "Appending -fno-stack-protector to CXXFLAGS"
219 append-cxxflags -fno-stack-protector 251 append-cxxflags -fno-stack-protector
220 # Bug 253127 252 # Bug 253127
221 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 253 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
222 -i mkspecs/common/g++.conf || die 254 -i mkspecs/common/g++.conf || die
233 CC='$(tc-getCC)'\n\ 265 CC='$(tc-getCC)'\n\
234 CXX='$(tc-getCXX)'\n\ 266 CXX='$(tc-getCXX)'\n\
235 CFLAGS='${CFLAGS}'\n\ 267 CFLAGS='${CFLAGS}'\n\
236 CXXFLAGS='${CXXFLAGS}'\n\ 268 CXXFLAGS='${CXXFLAGS}'\n\
237 LDFLAGS='${LDFLAGS}'\n" \ 269 LDFLAGS='${LDFLAGS}'\n" \
270 -i configure \
238 -i configure || die "sed SYSTEM_VARIABLES failed" 271 || die "sed SYSTEM_VARIABLES failed"
239 272
240 # Bug 321335 273 # Respect CC, CXX, LINK and *FLAGS in config.tests
241 find config.tests/unix -name '*.test' -type f -exec grep -lZ \$MAKE '{}' \; | xargs -0 \ 274 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
242 sed -e "s:\(\$MAKE\):\1 CC='$(tc-getCC)' CXX='$(tc-getCXX)' LINK='$(tc-getCXX)':g" \ 275 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
243 -i || die "sed test compilers failed" 276 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
277 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
278 || die "sed config.tests failed"
279
280 if ! version_is_at_least 4.8; then
281 # Strip predefined CFLAGS from mkspecs (bugs 312689 and 352778)
282 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
283 fi
244 284
245 # Bug 172219 285 # Bug 172219
246 sed -e "s:X11R6/::" -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 286 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
247 287
248 if [[ ${CHOST} == *-darwin* ]]; then 288 if [[ ${CHOST} == *-darwin* ]]; then
249 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 289 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
250 # crippled (by design) :/ 290 # crippled (by design) :/
291 local mac_gpp_conf=
292 if [[ -f mkspecs/common/mac-g++.conf ]]; then
293 # qt < 4.8 has mac-g++.conf
294 mac_gpp_conf="mkspecs/common/mac-g++.conf"
295 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
296 # qt >= 4.8 has g++-macx.conf
297 mac_gpp_conf="mkspecs/common/g++-macx.conf"
298 else
299 die "no known conf file for mac found"
300 fi
301 sed \
251 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 302 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
252 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 303 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
253 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 304 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
254 -e "s:-arch\s\w*::g" \ 305 -e "s:-arch\s\w*::g" \
255 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 306 -i ${mac_gpp_conf} \
307 || die "sed ${mac_gpp_conf} failed"
256 308
257 # Fix configure's -arch settings that appear in qmake/Makefile and also 309 # Fix configure's -arch settings that appear in qmake/Makefile and also
258 # fix arch handling (automagically duplicates our -arch arg and breaks 310 # fix arch handling (automagically duplicates our -arch arg and breaks
259 # pch). Additionally disable Xarch support. 311 # pch). Additionally disable Xarch support.
312 local mac_gcc_confs="${mac_gpp_conf}"
313 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
314 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
315 fi
260 sed \ 316 sed \
261 -e "s:-arch i386::" \ 317 -e "s:-arch i386::" \
262 -e "s:-arch ppc::" \ 318 -e "s:-arch ppc::" \
263 -e "s:-arch x86_64::" \ 319 -e "s:-arch x86_64::" \
264 -e "s:-arch ppc64::" \ 320 -e "s:-arch ppc64::" \
265 -e "s:-arch \$i::" \ 321 -e "s:-arch \$i::" \
266 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 322 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
267 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 323 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
268 -e "s:-Xarch_x86_64::g" \ 324 -e "s:-Xarch_x86_64::g" \
269 -e "s:-Xarch_ppc64::g" \ 325 -e "s:-Xarch_ppc64::g" \
270 -i configure mkspecs/common/mac-g++.conf || die "sed -arch/-Xarch failed" 326 -i configure ${mac_gcc_confs} \
327 || die "sed -arch/-Xarch failed"
271 328
272 # On Snow Leopard don't fall back to 10.5 deployment target. 329 # On Snow Leopard don't fall back to 10.5 deployment target.
273 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 330 if [[ ${CHOST} == *-apple-darwin10 ]]; then
274 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 331 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
275 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 332 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
276 -i configure mkspecs/common/mac-g++.conf || die "sed deployment target failed" 333 -i configure ${mac_gpp_conf} \
334 || die "sed deployment target failed"
277 fi 335 fi
278 fi 336 fi
279 337
280 # this one is needed for all systems with a separate -liconv, apart from 338 # this one is needed for all systems with a separate -liconv, apart from
281 # Darwin, for which the sources already cater for -liconv 339 # Darwin, for which the sources already cater for -liconv
282 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 340 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
283 sed \ 341 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
284 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
285 -i config.tests/unix/iconv/iconv.pro \ 342 -i config.tests/unix/iconv/iconv.pro \
286 || die "sed on iconv.pro failed" 343 || die "sed iconv.pro failed"
287 fi 344 fi
288 345
289 # we need some patches for Solaris 346 # we need some patches for Solaris
290 sed -i \
291 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 347 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
292 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 348 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
293 # use GCC over SunStudio 349 # use GCC over SunStudio
294 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 350 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
295 # don't flirt with non-Prefix stuff, we're quite possessive 351 # do not flirt with non-Prefix stuff, we're quite possessive
296 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 352 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
297 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 353 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
298 # strip predefined CFLAGS from qmake ( bug #312689 )
299 sed -i '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf
300 354
301 base_src_prepare 355 # apply patches
356 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
357 epatch_user
302} 358}
303 359
304# @FUNCTION: qt4-build_src_configure 360# @FUNCTION: qt4-build_src_configure
305# @DESCRIPTION: 361# @DESCRIPTION:
306# Default configure phase 362# Default configure phase
307qt4-build_src_configure() { 363qt4-build_src_configure() {
308 setqtenv 364 setqtenv
309 myconf="$(standard_configure_options) ${myconf}" 365
366 local conf="
367 -prefix ${QTPREFIXDIR}
368 -bindir ${QTBINDIR}
369 -libdir ${QTLIBDIR}
370 -docdir ${QTDOCDIR}
371 -headerdir ${QTHEADERDIR}
372 -plugindir ${QTPLUGINDIR}
373 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
374 -datadir ${QTDATADIR}
375 -translationdir ${QTTRANSDIR}
376 -sysconfdir ${QTSYSCONFDIR}
377 -examplesdir ${QTEXAMPLESDIR}
378 -demosdir ${QTDEMOSDIR}
379 -opensource -confirm-license
380 -shared -fast -largefile -stl -verbose
381 -nomake examples -nomake demos"
382
383 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
384 # $(tc-arch). Therefore we convert it to supported values.
385 case "$(tc-arch)" in
386 amd64|x64-*) conf+=" -arch x86_64" ;;
387 ppc-macos) conf+=" -arch ppc" ;;
388 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
389 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
390 x86-macos) conf+=" -arch x86" ;;
391 x86|x86-*) conf+=" -arch i386" ;;
392 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
393 hppa|sh) conf+=" -arch generic" ;;
394 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
395 esac
396
397 conf+=" -platform $(qt_mkspecs_dir)"
398
399 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
400
401 # debug/release
402 if use debug; then
403 conf+=" -debug"
404 else
405 conf+=" -release"
406 fi
407 conf+=" -no-separate-debug-info"
408
409 # exceptions USE flag
410 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
411
412 # disable rpath on Qt >= 4.8 (bug 380415)
413 # but leave it enabled on prefix (bug 417169)
414 version_is_at_least 4.8 && use !prefix && conf+=" -no-rpath"
415
416 # precompiled headers don't work on hardened, where the flag is masked
417 conf+=" $(qt_use pch)"
418
419 # -reduce-relocations
420 # This flag seems to introduce major breakage to applications,
421 # mostly to be seen as a core dump with the message "QPixmap: Must
422 # construct a QApplication before a QPaintDevice" on Solaris.
423 # -- Daniel Vergien
424 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
310 425
311 # this one is needed for all systems with a separate -liconv, apart from 426 # this one is needed for all systems with a separate -liconv, apart from
312 # Darwin, for which the sources already cater for -liconv 427 # Darwin, for which the sources already cater for -liconv
313 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 428 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
314 myconf+=" -liconv" 429 conf+=" -liconv"
430 fi
315 431
316 if use_if_iuse glib; then 432 if use_if_iuse glib; then
317 # use -I, -L and -l from configure
318 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 433 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
319 # avoid the -pthread argument 434 # avoid the -pthread argument
320 myconf+=" ${glibflags//-pthread}" 435 conf+=" ${glibflags//-pthread}"
321 unset glibflags 436 unset glibflags
322 fi 437 fi
323 438
324 if use_if_iuse qpa; then 439 if use_if_iuse qpa; then
325 ewarn 440 echo
326 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely" 441 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
327 ewarn "known as Qt Lighthouse. If you are not sure what that is, then" 442 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
328 ewarn "disable it before reporting any bugs related to this useflag." 443 ewarn "disable it before reporting any bugs related to this useflag."
329 ewarn 444 echo
330 myconf+=" -qpa" 445 conf+=" -qpa"
331 fi 446 fi
332 447
333 if use aqua ; then 448 if use aqua; then
334 # On (snow) leopard use the new (frameworked) cocoa code. 449 # On (snow) leopard use the new (frameworked) cocoa code.
335 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 450 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
336 myconf+=" -cocoa -framework" 451 conf+=" -cocoa -framework"
452 # We need the source's headers, not the installed ones.
453 conf+=" -I${S}/include"
454 # Add hint for the framework location.
455 conf+=" -F${QTLIBDIR}"
337 456
338 # We are crazy and build cocoa + qt3support :-) 457 # We are crazy and build cocoa + qt3support :-)
339 if use qt3support; then 458 if use qt3support; then
340 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 459 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
341 -i configure 460 -i configure || die
342 fi 461 fi
343 462 else
344 # We need the source's headers, not the installed ones. 463 conf+=" -no-framework"
345 myconf+=" -I${S}/include"
346
347 # Add hint for the framework location.
348 myconf+=" -F${QTLIBDIR}"
349 fi 464 fi
350 else 465 else
351 # freetype2 include dir is non-standard, thus include it on configure 466 # freetype2 include dir is non-standard, thus pass it to configure
352 # use -I from configure
353 myconf+=" $(pkg-config --cflags freetype2)" 467 conf+=" $(pkg-config --cflags-only-I freetype2)"
354 fi 468 fi
355 469
470 conf+=" ${myconf}"
471 myconf=
472
356 echo ./configure ${myconf} 473 echo ./configure ${conf}
357 ./configure ${myconf} || die "./configure failed" 474 ./configure ${conf} || die "./configure failed"
358 myconf=""
359 475
360 prepare_directories ${QT4_TARGET_DIRECTORIES} 476 prepare_directories ${QT4_TARGET_DIRECTORIES}
361} 477}
362 478
363# @FUNCTION: qt4-build_src_compile 479# @FUNCTION: qt4-build_src_compile
371 487
372# @FUNCTION: qt4-build_src_test 488# @FUNCTION: qt4-build_src_test
373# @DESCRIPTION: 489# @DESCRIPTION:
374# Runs tests only in target directories. 490# Runs tests only in target directories.
375qt4-build_src_test() { 491qt4-build_src_test() {
492 # QtMultimedia does not have any test suite (bug #332299)
493 [[ ${PN} == qt-multimedia ]] && return
494
376 for dir in ${QT4_TARGET_DIRECTORIES}; do 495 for dir in ${QT4_TARGET_DIRECTORIES}; do
377 emake -j1 check -C ${dir} 496 emake -j1 check -C ${dir}
378 done 497 done
379} 498}
380 499
381# @FUNCTION: fix_includes 500# @FUNCTION: fix_includes
382# @DESCRIPTION: 501# @DESCRIPTION:
383# For MacOS X we need to add some symlinks when frameworks are 502# For MacOS X we need to add some symlinks when frameworks are
384# being used, to avoid complications with some more or less stupid packages. 503# being used, to avoid complications with some more or less stupid packages.
385fix_includes() { 504fix_includes() {
386 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 505 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
506 local frw dest f h rdir
387 # Some packages tend to include <Qt/...> 507 # Some packages tend to include <Qt/...>
388 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 508 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
389 509
390 # Fake normal headers when frameworks are installed... eases life later on 510 # Fake normal headers when frameworks are installed... eases life later
391 local dest f 511 # on, make sure we use relative links though, as some ebuilds assume
512 # these dirs exist in src_install to add additional files
513 f=${QTHEADERDIR}
514 h=${QTLIBDIR}
515 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
516 f=${f#*/}
517 h=${h#*/}
518 done
519 rdir=${h}
520 f="../"
521 while [[ ${h} == */* ]] ; do
522 f="${f}../"
523 h=${h#*/}
524 done
525 rdir="${f}${rdir}"
526
392 for frw in "${D}${QTLIBDIR}"/*.framework; do 527 for frw in "${D}${QTLIBDIR}"/*.framework; do
393 [[ -e "${frw}"/Headers ]] || continue 528 [[ -e "${frw}"/Headers ]] || continue
394 f=$(basename ${frw}) 529 f=$(basename ${frw})
395 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 530 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
396 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 531 dosym "${rdir}"/${f}/Headers "${dest}"
397 532
398 # Link normal headers as well. 533 # Link normal headers as well.
399 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 534 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
400 h=$(basename ${hdr}) 535 h=$(basename ${hdr})
401 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 536 dosym "../${rdir}"/${f}/Headers/${h} \
537 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
402 done 538 done
403 done 539 done
404 fi 540 fi
405} 541}
406 542
415 install_qconfigs 551 install_qconfigs
416 fix_library_files 552 fix_library_files
417 fix_includes 553 fix_includes
418 554
419 # remove .la files since we are building only shared Qt libraries 555 # remove .la files since we are building only shared Qt libraries
420 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm 556 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
421} 557}
422 558
423# @FUNCTION: setqtenv 559# @FUNCTION: setqtenv
424# @INTERNAL 560# @INTERNAL
425setqtenv() { 561setqtenv() {
439 QTDEMOSDIR=${QTDATADIR}/demos 575 QTDEMOSDIR=${QTDATADIR}/demos
440 QMAKE_LIBDIR_QT=${QTLIBDIR} 576 QMAKE_LIBDIR_QT=${QTLIBDIR}
441 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 577 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
442 578
443 PLATFORM=$(qt_mkspecs_dir) 579 PLATFORM=$(qt_mkspecs_dir)
444
445 unset QMAKESPEC 580 unset QMAKESPEC
446}
447 581
448# @FUNCTION: standard_configure_options 582 export XDG_CONFIG_HOME="${T}"
449# @INTERNAL
450# @DESCRIPTION:
451# Sets up some standard configure options, like libdir (if necessary), whether
452# debug info is wanted or not.
453standard_configure_options() {
454 local myconf="-prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
455 -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR} -plugindir ${QTPLUGINDIR}
456 -importdir ${QTIMPORTDIR} -datadir ${QTDATADIR} -translationdir ${QTTRANSDIR}
457 -sysconfdir ${QTSYSCONFDIR} -examplesdir ${QTEXAMPLESDIR} -demosdir ${QTDEMOSDIR}
458 -opensource -confirm-license -shared -fast -largefile -stl -verbose
459 -platform $(qt_mkspecs_dir) -nomake examples -nomake demos"
460
461 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
462
463 # debug/release
464 if use debug; then
465 myconf+=" -debug"
466 else
467 myconf+=" -release"
468 fi
469 myconf+=" -no-separate-debug-info"
470
471 # exceptions USE flag
472 local exceptions="-exceptions"
473 in_iuse exceptions && exceptions="$(qt_use exceptions)"
474 myconf+=" ${exceptions}"
475
476 # disable RPATH on Qt >= 4.8 (bug 380415)
477 version_is_at_least 4.8 && myconf+=" -no-rpath"
478
479 # precompiled headers don't work on hardened, where the flag is masked
480 myconf+=" $(qt_use pch)"
481
482 # -reduce-relocations
483 # This flag seems to introduce major breakage to applications,
484 # mostly to be seen as a core dump with the message "QPixmap: Must
485 # construct a QApplication before a QPaintDevice" on Solaris.
486 # -- Daniel Vergien
487 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
488
489 use aqua && myconf+=" -no-framework"
490
491 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
492 # $(tc-arch). Therefore we convert it to supported values.
493 case "$(tc-arch)" in
494 amd64|x64-*) myconf+=" -arch x86_64" ;;
495 ppc-macos) myconf+=" -arch ppc" ;;
496 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
497 sparc|sparc-*|sparc64-*) myconf+=" -arch sparc" ;;
498 x86-macos) myconf+=" -arch x86" ;;
499 x86|x86-*) myconf+=" -arch i386" ;;
500 alpha|arm|ia64|mips|s390) myconf+=" -arch $(tc-arch)" ;;
501 hppa|sh) myconf+=" -arch generic" ;;
502 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
503 esac
504
505 echo "${myconf}"
506} 583}
507 584
508# @FUNCTION: prepare_directories 585# @FUNCTION: prepare_directories
509# @USAGE: < directories > 586# @USAGE: < directories >
510# @INTERNAL 587# @INTERNAL
597# @FUNCTION: generate_qconfigs 674# @FUNCTION: generate_qconfigs
598# @INTERNAL 675# @INTERNAL
599# @DESCRIPTION: 676# @DESCRIPTION:
600# Generates gentoo-specific qconfig.{h,pri}. 677# Generates gentoo-specific qconfig.{h,pri}.
601generate_qconfigs() { 678generate_qconfigs() {
602 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 679 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
603 local x qconfig_add qconfig_remove qconfig_new 680 local x qconfig_add qconfig_remove qconfig_new
604 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 681 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
605 [[ -f ${x} ]] || continue 682 [[ -f ${x} ]] || continue
606 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 683 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
607 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 684 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
738# @RETURN: the specs-directory w/o path 815# @RETURN: the specs-directory w/o path
739# @DESCRIPTION: 816# @DESCRIPTION:
740# Allows us to define which mkspecs dir we want to use. 817# Allows us to define which mkspecs dir we want to use.
741qt_mkspecs_dir() { 818qt_mkspecs_dir() {
742 local spec= 819 local spec=
820
743 case ${CHOST} in 821 case "${CHOST}" in
744 *-freebsd*|*-dragonfly*) 822 *-freebsd*|*-dragonfly*)
745 spec=freebsd ;; 823 spec=freebsd ;;
746 *-openbsd*) 824 *-openbsd*)
747 spec=openbsd ;; 825 spec=openbsd ;;
748 *-netbsd*) 826 *-netbsd*)
759 *-solaris*) 837 *-solaris*)
760 spec=solaris ;; 838 spec=solaris ;;
761 *-linux-*|*-linux) 839 *-linux-*|*-linux)
762 spec=linux ;; 840 spec=linux ;;
763 *) 841 *)
764 die "Unknown CHOST, no platform chosen" 842 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
765 esac 843 esac
766 844
767 CXX=$(tc-getCXX) 845 case "$(tc-getCXX)" in
768 if [[ ${CXX} == *g++* ]]; then 846 *g++*)
769 spec+=-g++ 847 spec+=-g++ ;;
770 elif [[ ${CXX} == *icpc* ]]; then 848 *icpc*)
771 spec+=-icc 849 spec+=-icc ;;
772 else 850 *)
773 die "Unknown compiler '${CXX}'" 851 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
774 fi 852 esac
775 if [[ -n ${LIBDIR/lib} ]]; then
776 spec+=-${LIBDIR/lib}
777 fi
778 853
779 # Add -64 for 64bit profiles 854 # Add -64 for 64bit profiles
780 if use x64-freebsd || 855 if use x64-freebsd ||
781 use amd64-linux || 856 use amd64-linux ||
782 use x64-macos || 857 use x64-macos ||
787 fi 862 fi
788 863
789 echo "${spec}" 864 echo "${spec}"
790} 865}
791 866
792# @FUNCTION: qt_assistant_cleanup
793# @INTERNAL
794# @DESCRIPTION:
795# Tries to clean up tools.pro for qt-assistant ebuilds.
796# Meant to be called in src_prepare().
797# Since Qt 4.7.4 this function is a no-op.
798qt_assistant_cleanup() {
799 # apply patching to qt-assistant ebuilds only
800 [[ ${PN} != "qt-assistant" ]] && return
801
802 # no longer needed for 4.7.4 and later
803 version_is_at_least "4.7.4" && return
804
805 # different versions (and branches...) may need different handling,
806 # add a case if you need special handling
807 case "${MY_PV_EXTRA}" in
808 *kde-qt*)
809 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
810 -e "/mac/,/^embedded.*makeqpf$/d" \
811 -i tools/tools.pro || die "patching tools.pro failed"
812 ;;
813 *)
814 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
815 -e "/mac/,/^embedded.*makeqpf$/d" \
816 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
817 -i tools/tools.pro || die "patching tools.pro failed"
818 ;;
819 esac
820}
821
822# @FUNCTION: qt_nolibx11 867# @FUNCTION: qt_nolibx11
823# @INTERNAL 868# @INTERNAL
824# @DESCRIPTION: 869# @DESCRIPTION:
825# Ignore X11 tests for packages that don't need X libraries installed. 870# Ignore X11 tests for packages that don't need X libraries installed.
826qt_nolibx11() { 871qt_nolibx11() {

Legend:
Removed from v.1.111  
changed lines
  Added in v.1.134

  ViewVC Help
Powered by ViewVC 1.1.20